<template>
  <div>
    <span @click.stop="click">
      <!-- disabled: 主动禁用 permission: 权限  switchable: 操作后一定时间内禁用 -->
      <el-switch
        :disabled="disabled || permission() || switchable"
        :value="value"
        active-color="#bd1a2d"
        inactive-color="#f2f2f2"
      />
    </span>
  </div>
</template>

<script>
export default {
  props: {
    checkPermission: {
      type: String,
      default: ''
    },
    value: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      switchable: false
    }
  },
  methods: {
    click() {
      if (!(this.disabled || this.permission() || this.switchable)) {
        this.switchable = true
        this.$emit('click')
        setTimeout(() => {
          this.switchable = false
        }, 1000)// 一秒内不能重复点击
      }
    },
    // 检查按钮权限
    permission() {
      if (this.checkPermission && this.$store.getters.myButtonPermission.indexOf(this.checkPermission) < 0) {
        return true
      }
      return false
    }
  }
}
</script>
